Bug 847901 - Review Request: spamprobe - A Bayesian spam filter
Review Request: spamprobe - A Bayesian spam filter
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Kevin Fenzi
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-08-13 19:39 EDT by Steven Roberts
Modified: 2013-10-19 10:42 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-09-12 15:28:39 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
kevin: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Steven Roberts 2012-08-13 19:39:43 EDT
Spec URL: http://rpm.ysl.org/fedora-review/spamprobe.spec
SRPM URL: http://rpm.ysl.org/fedora-review/spamprobe-1.4d-2.src.rpm
Description: 
A spam filter that takes a different approach from the typical        
hand crafted rules based systems.  Instead of using pattern matching  
and a set of human generated rules SpamProbe relies on a Bayesian     
analysis of the frequency of words used in spam and non-spam emails   
received by an individual person.  The process is completely automatic
and tailors itself to the kinds of emails that each person receives.  
Spamprobe is not a mail filtering program itself but is designed to   
plug into another mail filtering system like procmail or              
Perl Mail::Procmail.                                                  

Fedora Account System Username: strobert

Koji build results:
f18 - https://koji.fedoraproject.org/koji/taskinfo?taskID=4386874
f17 - https://koji.fedoraproject.org/koji/taskinfo?taskID=4386887
f16 - https://koji.fedoraproject.org/koji/taskinfo?taskID=4386890
EL5 - https://koji.fedoraproject.org/koji/taskinfo?taskID=4386893
EL6 - https://koji.fedoraproject.org/koji/taskinfo?taskID=4386897

Build succeeded on all 5.

This is my first Fedora package and thus I will need a sponsor. 

I am in touch with the upstream for spamprobe and working on getting the patches integrated into the source tree and the next release.
Comment 1 Kevin Fenzi 2012-08-13 20:01:24 EDT
I'll try and look at this in the next few days, but anyone else can feel free to do so sooner if they like. ;)
Comment 2 Steven Roberts 2012-08-13 20:17:30 EDT
updated make invocation to use %{?_smp_mflags} for parallel building.  specfile and SRPM updated.

did tests locally on a centos6 box with -J 3 set, koji f18, and koji EL6 and all worked fine.
Comment 3 Kevin Fenzi 2012-08-18 15:56:46 EDT
Look for a review on this hopefully later today...
Comment 4 Kevin Fenzi 2012-08-18 16:05:38 EDT
Some general comments/suggestions/changes before the review: 

1. Please don't define %{prefix}

2. (not a blocker, but IMHO a good idea) consider using the dist tag on your version
http://fedoraproject.org/wiki/Packaging:DistTag

3. If you can avoid using %makeinstall that would be good. See: 
http://fedoraproject.org/wiki/Packaging:Guidelines#Why_the_.25makeinstall_macro_should_not_be_used

4. I'm assuming upstream releases packages in a post release a, b, c, d, way right? 
If so, then your version is fine. If not you may want to look at: 
http://fedoraproject.org/wiki/Packaging:NamingGuidelines#Post-Release_packages
and add a note/comment in the spec about what upstream does here. ;)
Comment 5 Steven Roberts 2012-08-21 15:49:46 EDT
1. dropped the prefix specification.  This spec file was created a while ago and back then was cut from template that used relocatable packages.  It was back in the days before LVM2, yum and was best practices at the time.  I read the Fedora guidelines on it and makes sense to drop it in this day and age.

2. I had thought about adding it (I've seen it as a user for years now) but I thought someplace I read that you should only do so when needed.  I re-read that disttag page and sounds like it is recommended.  so I've added it.

3. I had some weird compiler errors when using %make_install instead of %makeinstall.

4.  Yup, that is the upstream naming.  Added a comment in the spec file.  it is like openssh and 4.3p2 :).


I'm going to poke at makeinstall a bit more and I'll post back in here on what I'm able to come up with.
Comment 6 Steven Roberts 2012-08-21 16:02:20 EDT
new SRPM URL: http://rpm.ysl.org/fedora-review/spamprobe-1.4d-2.el6.src.rpm

%make_install is not available under EL 5, hence the compile errors.  I switched to using: 'make DESTDIR=%{buildroot} install' and that works on all 5 of the platforms I listed above.

new SRPM, spec file uploaded.
Comment 7 Steven Roberts 2012-08-21 16:38:25 EDT
thank you for the feedback.  please let me know what I should be changing still :)
Comment 8 Kevin Fenzi 2012-08-25 14:20:50 EDT
So, here's what fedora-review says: 



Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Header files in -devel subpackage, if present.
[x]: MUST Package does not contain any libtool archives (.la)
[ ]: MUST Package does not contain kernel modules.
[ ]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.


==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[ ]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[ ]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[ ]: MUST Package contains no bundled libraries.
[ ]: MUST Changelog in prescribed format.
[ ]: MUST Sources contain only permissible code or content.
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files section. This is OK if packaging
     for EPEL5. Otherwise not needed
[ ]: MUST Macros in Summary, %description expandable at SRPM build time.
[ ]: MUST Package contains desktop file if it is a GUI application.
[ ]: MUST Development files must be in a -devel package
[ ]: MUST Package requires other packages for directories it uses.
[ ]: MUST Package uses nothing in %doc for runtime.
[ ]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[ ]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
[ ]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[ ]: MUST License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "zlib/libpng" For detailed output of licensecheck see file:
     /home/kevin/847901-spamprobe/licensecheck.txt
[!]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
     Note: Using both %{buildroot} and $RPM_BUILD_ROOT
[x]: MUST Package is named using only allowed ascii characters.
[ ]: MUST Package is named according to the Package Naming Guidelines.
[ ]: MUST Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[ ]: MUST Package obeys FHS, except libexecdir and /usr/target.
[ ]: MUST If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: MUST Package must own all directories that it creates.
[ ]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[ ]: MUST Package is not relocatable.
[ ]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[ ]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[ ]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[ ]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[!]: SHOULD Buildroot is not present
     Note: Buildroot is not needed unless packager plans to package for EPEL5
[!]: SHOULD Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL5
[ ]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[ ]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[ ]: SHOULD Package functions as described.
[ ]: SHOULD Latest version is packaged.
[ ]: SHOULD Package does not include license text files separate from
     upstream.
[ ]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: SHOULD SourceX tarball generation or download is documented.
[!]: SHOULD SourceX / PatchY prefixed with %{name}.
     Note: Patch0 (compile-fixes.patch) Patch1 (64bit.patch) Patch2 (example-
     swapped.patch)
[x]: SHOULD SourceX is a working URL.
[ ]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[ ]: SHOULD %check is present and all tests pass.
[ ]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files section. This is OK if packaging
     for EPEL5. Otherwise not needed
See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
See: None
[!]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
     Note: Using both %{buildroot} and $RPM_BUILD_ROOT
See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros

Rpmlint
-------
Checking: spamprobe-1.4d-2.fc16.x86_64.rpm
          spamprobe-1.4d-2.fc16.src.rpm
          spamprobe-debuginfo-1.4d-2.fc16.x86_64.rpm
spamprobe.x86_64: W: spelling-error %description -l en_US procmail -> proclaim, procaine
spamprobe.x86_64: W: spelling-error %description -l en_US Procmail -> Proclaim, Procaine
spamprobe.x86_64: W: manual-page-warning /usr/share/man/man1/spamprobe.1.gz 610: normal or special character expected (got a node)
spamprobe.src: W: spelling-error %description -l en_US procmail -> proclaim, procaine
spamprobe.src: W: spelling-error %description -l en_US Procmail -> Proclaim, Procaine
spamprobe.src: W: strange-permission spamprobe-1.4d.tar.gz 0775L
spamprobe.src:62: W: macro-in-%changelog %makeinstall
3 packages and 0 specfiles checked; 0 errors, 7 warnings.


Rpmlint (installed packages)
----------------------------
# rpmlint spamprobe-debuginfo
spamprobe-debuginfo.x86_64: I: enchant-dictionary-not-found en_US
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'

Requires
--------
spamprobe-1.4d-2.fc16.x86_64.rpm (rpmlib, GLIBC filtered):
    
    libc.so.6()(64bit)
    libdb-4.8.so()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)

spamprobe-debuginfo-1.4d-2.fc16.x86_64.rpm (rpmlib, GLIBC filtered):
    

Provides
--------
spamprobe-1.4d-2.fc16.x86_64.rpm:
    
    spamprobe = 1.4d-2.fc16
    spamprobe(x86-64) = 1.4d-2.fc16

spamprobe-debuginfo-1.4d-2.fc16.x86_64.rpm:
    
    spamprobe-debuginfo = 1.4d-2.fc16
    spamprobe-debuginfo(x86-64) = 1.4d-2.fc16

MD5-sum check
-------------
http://prdownloads.sourceforge.net/spamprobe/spamprobe-1.4d.tar.gz :
  CHECKSUM(SHA256) this package     : 217ce47dcc6f58d8201fbb0a5e2dc38b5b06349fadb1378fb3647ad8a3f44d68
  CHECKSUM(SHA256) upstream package : 217ce47dcc6f58d8201fbb0a5e2dc38b5b06349fadb1378fb3647ad8a3f44d68


Generated by fedora-review 0.2.2 (9f8c0e5) last change: 2012-08-09
Command line :/usr/bin/fedora-review -b 847901
External plugins:

So, the items I would say should be fixed (although none of them are serious): 

1. spamprobe.src:62: W: macro-in-%changelog %makeinstall
In rpm spec files you have to use %% to produce a non macro %

2. [!]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
     Note: Using both %{buildroot} and $RPM_BUILD_ROOT
See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros

Fix those and I think we are in pretty good shape. ;)
Comment 9 Steven Roberts 2012-08-26 01:14:39 EDT
Did the two changes.  New spec,SRPM uploaded.

Funny, those were from me dropping %makeinstall :)

I had actually just started looking at fedora-review.  I was reading the fedora review SIG pages.
Comment 10 Kevin Fenzi 2012-08-26 11:43:47 EDT
FYI, moving forward, it's good to bump release and add a changelog entry for each set of changes in a review (this avoids confusion as to what exact version of the spec is being reviewed).

You may want to adjust the Source url per: 
http://fedoraproject.org/wiki/Packaging:SourceURL#Sourceforge.net
(You can do that before you import it)

I don't see any further blockers here though, so this package is APPROVED. 

I'll go ahead and sponsor you. If you have any questions or concerns about the process feel free to catch me on irc (my nick is nirik) or drop me an email. 

Welcome to the fun. ;)
Comment 11 Steven Roberts 2012-08-26 18:48:22 EDT
I was wondering about bumping the the release number.  I wasn't sure if should bump inside of a review.  I'm good with bumping the number more often.

Thank you for the sourceforge link.  I had been having difficulty finding a good reference on SF.net as to what direct link to use.  I thinkt he prdownloads is likely an older one.

I've change the link (and upped the released number :) )

Thank you for the review and sponsorship.  A bit energizing to be more active in the Open Source community again.
Comment 12 Steven Roberts 2012-08-26 20:27:46 EDT
New Package SCM Request
=======================
Package Name: spamprobe
Short Description: A Bayesian spam filter
Owners: strobert
Branches: f16 f17 f18 el5 el6
InitialCC:
Comment 13 Jon Ciesla 2012-08-26 21:47:44 EDT
Git done (by process-git-requests).
Comment 14 Fedora Update System 2012-08-27 00:14:55 EDT
spamprobe-1.4d-3.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/spamprobe-1.4d-3.el5
Comment 15 Fedora Update System 2012-08-27 01:03:19 EDT
spamprobe-1.4d-3.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/spamprobe-1.4d-3.fc16
Comment 16 Fedora Update System 2012-08-27 01:35:07 EDT
spamprobe-1.4d-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/spamprobe-1.4d-3.fc17
Comment 17 Fedora Update System 2012-08-27 01:44:50 EDT
spamprobe-1.4d-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/spamprobe-1.4d-3.fc18
Comment 18 Fedora Update System 2012-08-27 01:53:13 EDT
spamprobe-1.4d-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/spamprobe-1.4d-3.el6
Comment 19 Fedora Update System 2012-08-27 13:04:08 EDT
spamprobe-1.4d-3.el5 has been pushed to the Fedora EPEL 5 testing repository.
Comment 20 Fedora Update System 2012-09-12 15:27:29 EDT
spamprobe-1.4d-3.el6 has been pushed to the Fedora EPEL 6 stable repository.
Comment 21 Fedora Update System 2012-09-12 15:28:39 EDT
spamprobe-1.4d-3.el5 has been pushed to the Fedora EPEL 5 stable repository.
Comment 22 Fedora Update System 2012-09-17 13:52:23 EDT
spamprobe-1.4d-3.fc17 has been pushed to the Fedora 17 stable repository.
Comment 23 Fedora Update System 2012-09-17 13:56:30 EDT
spamprobe-1.4d-3.fc16 has been pushed to the Fedora 16 stable repository.
Comment 24 Fedora Update System 2012-09-17 20:04:50 EDT
spamprobe-1.4d-3.fc18 has been pushed to the Fedora 18 stable repository.

Note You need to log in before you can comment on or make changes to this bug.